/* flatten teapot */

#include "Include/Angel.h"

clock_t time0,time1;
float timer010;  // timer counting 0->1->0
bool bUp;        // flag if counting up or down.
GLuint program;
GLint loc;

//----------------------------------------------------------------------------
void UpdateTimer()
{
    
    time1 = clock();
    float delta = static_cast<float>(static_cast<double>(time1-time0)/static_cast<double>(CLOCKS_PER_SEC));
    delta = delta / 4;
    if (delta > 0.00005f)
    {
        time0 = clock();
        if (bUp)
        {
            timer010 += delta;
            if (timer010>=1.0f) { timer010 = 1.0f; bUp = false;}
        }
        else
        {
            timer010 -= delta;
            if (timer010<=0.0f) { timer010 = 0.0f; bUp = true;}
        }
    }
    glutPostRedisplay();
}
//----------------------------------------------------------------------------

void OnResize(int w, int h)
{
    if(h == 0) h = 1;
	   float ratio = 1.0f * (float)w / (float)h;
    
    glMatrixMode(GL_PROJECTION);
	   glLoadIdentity();
    
	   glViewport(0, 0, w, h);
    
    gluPerspective(45,ratio,1,100);
	   glMatrixMode(GL_MODELVIEW);
	   glLoadIdentity();
	   gluLookAt(0.0f,0.0f,5.0f,
                 0.0,0.0,0.0,
                 0.0f,1.0f,0.0f);
}

//----------------------------------------------------------------------------

void
init( void )
{
    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
    glEnable(GL_NORMALIZE);
    glClearColor(1.0,1.0,1.0,1.0);
    glShadeModel(GL_SMOOTH);
    glEnable(GL_DEPTH_TEST);
    
    // Load shaders and use the resulting shader program
    program = InitShader( "flattenVert.glsl", "flattenFrag.glsl" );
    glUseProgram( program );
    
    time0 = clock();
    timer010 = 0.0f;
    bUp = true;
    
}

//----------------------------------------------------------------------------

void
display( void )
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glPushMatrix();
    glRotatef(timer010*360,0.0f, 1.0f, 0.0f);
    glutSolidTeapot(1.0);
    glPopMatrix();
    glutSwapBuffers();
    
    
}
//----------------------------------------------------------------------------

void
keyboard( unsigned char key, int x, int y )
{
    switch ( key ) {
        case 033:
            exit( EXIT_SUCCESS );
            break;
    }
}

//----------------------------------------------------------------------------

int
main( int argc, char **argv )
{
    glutInit( &argc, argv );
    glutInitDisplayMode( GLUT_RGBA | GLUT_DEPTH );
    glutInitWindowSize( 512, 512 );
    glutCreateWindow( "Flatten Teapot" );
    glutReshapeFunc(OnResize);
    glutIdleFunc(UpdateTimer);
    init();
    
    glutDisplayFunc( display );
    glutKeyboardFunc( keyboard );
    
    glutMainLoop();
    return 0;
}
